POJ - 3126 Prime Path (搜索)

 

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:

给定两个四位数的素数作为开头和结尾,从起始素数开始,每步只能改变一位,并且改变后的数也是素数,问至少多少步能变到终止的素数。

打个1000~10000的素数表

bfs  遍历四个数位上的每个改变

 

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <queue>
using namespace std;
typedef long long ll;
const int N=1e4+30;
const int inf=0x3f3f3f3f;
int pri[N],tot=0;
bool vis[N],vi[N];
int n,m,cnt;
int dir[4]={1,10,100,1000};
void prime()
{
    memset(vis,0,sizeof(vis));
    memset(pri,0,sizeof(pri));
    vis[0]=vis[1]=1;
    for(int i=2;i<N;i++)
    {
        if(!vis[i])
        {
            pri[++tot]=i;
            for(int j=i+i;j<N;j+=i)
                vis[j]=1;
        }
    }
}
int step[N];
void bfs(int n)
{
    queue<int>q;
    q.push(n);
    vi[n]=1;
    while(q.size())
    {
        int tmp=q.front();
        q.pop();
        if(tmp==m)
        {
            cnt=step[tmp];
            return ;
        }
        for(int i=0;i<4;i++)
        {
            int num=(tmp/dir[i])%10;
            for(int j=0;j<=9;j++)
            {
                if(j==num||(i==3&&j==0))
                    continue;
                int nn=tmp-num*dir[i]+j*dir[i];
                if(!vis[nn]&&!vi[nn])
                {
                    vi[nn]=1;
                    q.push(nn);
                    step[nn]=step[tmp]+1;
                    if(nn==m)
                    {
                        cnt=step[nn];
                        return ;
                    }
                }
            }
        }
    }
}
int main()
{
    prime();
    int t;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        memset(vi,0,sizeof(vi));
        memset(step,0,sizeof(step));
        cnt=-1;
        bfs(n);
        cout<<cnt<<'\n';
    }
    return 0;
}

 

全部评论

相关推荐

头像
10-09 19:35
门头沟学院 Java
洛必不可达:java的竞争激烈程度是其他任何岗位的10到20倍
点赞 评论 收藏
分享
牛客101244697号:这个衣服和发型不去投偶像练习生?
点赞 评论 收藏
分享
评论
点赞
收藏
分享
牛客网
牛客企业服务